3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
48 if test "$1" = "#unmatched"
55 # Print a submodule configuration setting
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
71 value=$(git config submodule."$name"."$option")
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
100 # optional branch is stored in global branch variable
104 # parse $args after "submodule ... add".
110 case "$2" in '') usage ;; esac
121 case "$2" in '') usage ;; esac
126 reference_path="${1#--reference=}"
129 case "$2" in '') usage ;; esac
134 case "$2" in '') usage ;; esac
155 if test -n "$reference_path"
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
207 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
208 die "$(eval_gettext "'\$sm_path' already exists in the index")"
210 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
212 eval_gettextln "The following path is ignored by one of your .gitignore files:
214 Use -f if you really want to add it." >&2
218 if test -n "$custom_name"
220 sm_name="$custom_name"
225 # perhaps the path exists and is already a git repo, else clone it
226 if test -e "$sm_path"
228 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
230 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
232 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
236 if test -d ".git/modules/$sm_name"
240 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
241 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
242 die "$(eval_gettextln "\
243 If you want to reuse this local git directory instead of cloning again from
245 use the '--force' option. If the local git directory is not the correct repo
246 or you are unsure what this means choose another name with the '--name' option.")"
248 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
251 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
253 sanitize_submodule_env
255 # ash fails to wordsplit ${branch:+-b "$branch"...}
257 '') git checkout -f -q ;;
258 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
260 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
262 git config submodule."$sm_name".url "$realrepo"
264 git add $force "$sm_path" ||
265 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
267 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
268 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
271 git config -f .gitmodules submodule."$sm_name".branch "$branch"
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
278 # Execute an arbitrary command sequence in each checked out
281 # $@ = command to execute
285 # parse $args after "submodule ... foreach".
307 # dup stdin so that it can be restored when running the external
308 # command in the subshell (and a recursive call to this function)
312 git submodule--helper list --prefix "$wt_prefix" ||
315 while read mode sha1 stage sm_path
317 die_if_unmatched "$mode" "$sha1"
318 if test -e "$sm_path"/.git
320 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
321 say "$(eval_gettext "Entering '\$displaypath'")"
322 name=$(git submodule--helper name "$sm_path")
324 prefix="$prefix$sm_path/"
325 sanitize_submodule_env
327 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
328 # we make $path available to scripts ...
336 if test -n "$recursive"
338 cmd_foreach "--recursive" "$@"
341 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
347 # Register submodules in .git/config
349 # $@ = requested paths (default to all)
353 # parse $args after "submodule ... init".
374 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
378 # Unregister submodules from .git/config and remove their work tree
382 # parse $args after "submodule ... deinit".
410 if test -n "$deinit_all" && test "$#" -ne 0
412 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
415 if test $# = 0 && test -z "$deinit_all"
417 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
421 git submodule--helper list --prefix "$wt_prefix" "$@" ||
424 while read mode sha1 stage sm_path
426 die_if_unmatched "$mode" "$sha1"
427 name=$(git submodule--helper name "$sm_path") || exit
429 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
431 # Remove the submodule work tree (unless the user already did it)
432 if test -d "$sm_path"
434 # Protect submodules containing a .git directory
435 if test -d "$sm_path/.git"
437 die "$(eval_gettext "\
438 Submodule work tree '\$displaypath' contains a .git directory
439 (use 'rm -rf' if you really want to remove it including all of its history)")"
444 git rm -qn "$sm_path" ||
445 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
448 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
449 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
452 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
454 # Remove the .git/config entries (unless the user already did it)
455 if test -n "$(git config --get-regexp submodule."$name\.")"
457 # Remove the whole section so we have a clean state when
458 # the user later decides to init this submodule again
459 url=$(git config submodule."$name".url)
460 git config --remove-section submodule."$name" 2>/dev/null &&
461 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
466 is_tip_reachable () (
467 sanitize_submodule_env &&
469 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
473 fetch_in_submodule () (
474 sanitize_submodule_env &&
481 git fetch $(get_default_remote) "$@" ;;
486 # Update each submodule path to correct revision, using clone and checkout as needed
488 # $@ = requested paths (default to all)
492 # parse $args after "submodule ... update".
500 progress="--progress"
518 case "$2" in '') usage ;; esac
519 reference="--reference=$2"
535 recommend_shallow="--recommend-shallow"
537 --no-recommend-shallow)
538 recommend_shallow="--no-recommend-shallow"
541 case "$2" in '') usage ;; esac
549 case "$2" in '') usage ;; esac
572 cmd_init "--" "$@" || return
576 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
577 ${progress:+"$progress"} \
578 ${wt_prefix:+--prefix "$wt_prefix"} \
579 ${prefix:+--recursive-prefix "$prefix"} \
580 ${update:+--update "$update"} \
581 ${reference:+"$reference"} \
582 ${depth:+--depth "$depth"} \
583 ${recommend_shallow:+"$recommend_shallow"} \
585 "$@" || echo "#unmatched" $?
588 while read mode sha1 stage just_cloned sm_path
590 die_if_unmatched "$mode" "$sha1"
592 name=$(git submodule--helper name "$sm_path") || exit
593 url=$(git config submodule."$name".url)
594 if ! test -z "$update"
596 update_module=$update
598 update_module=$(git config submodule."$name".update)
599 if test -z "$update_module"
601 update_module="checkout"
605 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
607 if test $just_cloned -eq 1
610 update_module=checkout
612 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
613 git rev-parse --verify HEAD) ||
614 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
619 branch=$(git submodule--helper remote-branch "$sm_path")
620 if test -z "$nofetch"
622 # Fetch remote before determining tracking $sha1
623 fetch_in_submodule "$sm_path" $depth ||
624 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
626 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
627 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
628 git rev-parse --verify "${remote_name}/${branch}") ||
629 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
632 if test "$subsha1" != "$sha1" || test -n "$force"
635 # If we don't already have a -f flag and the submodule has never been checked out
636 if test -z "$subsha1" && test -z "$force"
641 if test -z "$nofetch"
643 # Run fetch only if $sha1 isn't present or it
644 # is not reachable from a ref.
645 is_tip_reachable "$sm_path" "$sha1" ||
646 fetch_in_submodule "$sm_path" $depth ||
647 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
649 # Now we tried the usual fetch, but $sha1 may
650 # not be reachable from any of the refs
651 is_tip_reachable "$sm_path" "$sha1" ||
652 fetch_in_submodule "$sm_path" $depth "$sha1" ||
653 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
657 case "$update_module" in
659 command="git checkout $subforce -q"
660 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
661 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
665 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
666 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
667 must_die_on_failure=yes
671 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
672 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
673 must_die_on_failure=yes
676 command="${update_module#!}"
677 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
678 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
679 must_die_on_failure=yes
682 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
685 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
688 elif test -n "$must_die_on_failure"
690 die_with_status 2 "$die_msg"
692 err="${err};$die_msg"
697 if test -n "$recursive"
700 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
702 sanitize_submodule_env
709 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
712 err="${err};$die_msg"
715 die_with_status $res "$die_msg"
740 sanitize_submodule_env
742 git describe "$2" 2>/dev/null ||
743 git describe --tags "$2" 2>/dev/null ||
744 git describe --contains "$2" 2>/dev/null ||
745 git describe --all --always "$2"
748 test -z "$revname" || revname=" ($revname)"
751 # Show commit summary for submodules in index or working tree
753 # If '--cached' is given, show summary between index and given commit,
754 # or between working tree and given commit
756 # $@ = [commit (default 'HEAD'),] requested paths (default all)
763 # parse $args after "submodule ... summary".
778 isnumber "$summary_limit" || usage
782 summary_limit="${1#--summary-limit=}"
783 isnumber "$summary_limit" || usage
799 test $summary_limit = 0 && return
801 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
805 elif test -z "$1" || test "$1" = "HEAD"
807 # before the first commit: compare with an empty tree
808 head=$(git hash-object -w -t tree --stdin </dev/null)
809 test -z "$1" || shift
817 die "$(gettext "The --cached option cannot be used with the --files option")"
823 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
824 # Get modified modules cared by user
825 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
826 sane_egrep '^:([0-7]* )?160000' |
827 while read mod_src mod_dst sha1_src sha1_dst status sm_path
829 # Always show modules deleted or type-changed (blob<->module)
830 if test "$status" = D || test "$status" = T
832 printf '%s\n' "$sm_path"
835 # Respect the ignore setting for --for-status.
836 if test -n "$for_status"
838 name=$(git submodule--helper name "$sm_path")
839 ignore_config=$(get_submodule_config "$name" ignore none)
840 test $status != A && test $ignore_config = all && continue
842 # Also show added or modified modules which are checked out
843 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
844 printf '%s\n' "$sm_path"
848 test -z "$modules" && return
850 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
851 sane_egrep '^:([0-7]* )?160000' |
853 while read mod_src mod_dst sha1_src sha1_dst status name
855 if test -z "$cached" &&
856 test $sha1_dst = 0000000000000000000000000000000000000000
860 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
862 100644 | 100755 | 120000)
863 sha1_dst=$(git hash-object $name)
869 eval_gettextln "unexpected mode \$mod_dst" >&2
876 test $mod_src = 160000 &&
877 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
880 test $mod_dst = 160000 &&
881 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
884 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
887 case "$missing_src,$missing_dst" in
889 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
892 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
895 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
900 if test $mod_src = 160000 && test $mod_dst = 160000
902 range="$sha1_src...$sha1_dst"
903 elif test $mod_src = 160000
909 GIT_DIR="$name/.git" \
910 git rev-list --first-parent $range -- | wc -l
912 total_commits=" ($(($total_commits + 0)))"
916 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
917 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
920 blob="$(gettext "blob")"
921 submodule="$(gettext "submodule")"
922 if test $mod_dst = 160000
924 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
926 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
929 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
933 # Don't give error msg for modification whose dst is not submodule
934 # i.e. deleted or changed to blob
935 test $mod_dst = 160000 && echo "$errmsg"
937 if test $mod_src = 160000 && test $mod_dst = 160000
940 test $summary_limit -gt 0 && limit="-$summary_limit"
941 GIT_DIR="$name/.git" \
942 git log $limit --pretty='format: %m %s' \
943 --first-parent $sha1_src...$sha1_dst
944 elif test $mod_dst = 160000
946 GIT_DIR="$name/.git" \
947 git log --pretty='format: > %s' -1 $sha1_dst
949 GIT_DIR="$name/.git" \
950 git log --pretty='format: < %s' -1 $sha1_src
958 # List all submodules, prefixed with:
959 # - submodule not initialized
960 # + different revision checked out
962 # If --cached was specified the revision in the index will be printed
963 # instead of the currently checked out revision.
965 # $@ = requested paths (default to all)
969 # parse $args after "submodule ... status".
997 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1000 while read mode sha1 stage sm_path
1002 die_if_unmatched "$mode" "$sha1"
1003 name=$(git submodule--helper name "$sm_path") || exit
1004 url=$(git config submodule."$name".url)
1005 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1006 if test "$stage" = U
1008 say "U$sha1 $displaypath"
1011 if test -z "$url" ||
1013 ! test -d "$sm_path"/.git &&
1014 ! test -f "$sm_path"/.git
1017 say "-$sha1 $displaypath"
1020 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1022 set_name_rev "$sm_path" "$sha1"
1023 say " $sha1 $displaypath$revname"
1025 if test -z "$cached"
1027 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1029 set_name_rev "$sm_path" "$sha1"
1030 say "+$sha1 $displaypath$revname"
1033 if test -n "$recursive"
1036 prefix="$displaypath/"
1037 sanitize_submodule_env
1042 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1047 # Sync remote urls for submodules
1048 # This makes the value for remote.$remote.url match the value
1049 # specified in .gitmodules.
1078 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1079 echo "#unmatched" $?
1081 while read mode sha1 stage sm_path
1083 die_if_unmatched "$mode" "$sha1"
1084 name=$(git submodule--helper name "$sm_path")
1085 url=$(git config -f .gitmodules --get submodule."$name".url)
1087 # Possibly a url relative to parent
1090 # rewrite foo/bar as ../.. to find path from
1091 # submodule work tree to superproject work tree
1092 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1093 # guarantee a trailing /
1094 up_path=${up_path%/}/ &&
1095 # path from submodule work tree to submodule origin repo
1096 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1097 # path from superproject work tree to submodule origin repo
1098 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1101 sub_origin_url="$url"
1102 super_config_url="$url"
1106 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1108 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1109 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1110 git config submodule."$name".url "$super_config_url"
1112 if test -e "$sm_path"/.git
1115 sanitize_submodule_env
1117 remote=$(get_default_remote)
1118 git config remote."$remote".url "$sub_origin_url"
1120 if test -n "$recursive"
1122 prefix="$prefix$sm_path/"
1133 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1136 # This loop parses the command line arguments to find the
1137 # subcommand name to dispatch. Parsing of the subcommand specific
1138 # options are primarily done by the subcommand implementations.
1139 # Subcommand specific options such as --branch and --cached are
1140 # parsed here as well, for backward compatibility.
1142 while test $# != 0 && test -z "$command"
1145 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1175 # No command word defaults to "status"
1176 if test -z "$command"
1186 # "-b branch" is accepted only by "add"
1187 if test -n "$branch" && test "$command" != add
1192 # "--cached" is accepted only by "status" and "summary"
1193 if test -n "$cached" && test "$command" != status && test "$command" != summary